package lawOfDemeter;

import java.util.*;

// the only aspect we need for this simplified version
public aspect Checker extends Supplier
  {
  before(): // check
    // we check method calls because 1. we need the this and target object
    // 2. we can check more.
    // http://aspectj.org/doc/dist/faq.html#q:comparecallandexecution
    // the meaning of the signature in the execution() and call()
    // pointcut designators (PCD's) differ:
    // the call type depends upon the type of the reference making the call,
    // while the execution type depends on the enclosing class.
    Any.MethodCall() {
    // we don't need the currently executing object.
    // Object thiz = thisJoinPoint.getThis();
    Object target = thisJoinPoint.getTarget();

    System.out.println("Checking--" + thisJoinPoint + at(thisJoinPoint));
    // for debugging

    // UNKNOWN 1:
    // INSERT YOUR CODE for
    // print the allowed target objects for the current method call.
    // Call method printHashMap.
    printHashMap(targets);
    // END INSERT YOUR CODE

    // if the target is not a preferred supplier -> Violation
    if (!contains(target))
      System.out.println(" !! LoD Violation !! ");
  }

  // needed for arguments!
  boolean contains(Object target) {

     // UNKNOWN 2:
     // INSERT YOUR CODE for
     // check whether target is contained in the allowed target objects (arguments).
     // Call method contains.
     return super.contains(target);
     // END INSERT YOUR CODE

  }


  // ==== arguments

  // UNKNOWN 3:
  // INSERT YOUR CODE for
  // making the program work correctly
  Stack argStack = new Stack();
  Object around(): Any.Execution(){
      // before a method executes, we store the arguments of the method
      argStack.push(targets);
      targets = new HashMap();
      addAll(thisJoinPoint.getArgs(), argument + at(thisJoinPoint));
      // arguments include this/self - store the object currently executing
      add(thisJoinPoint.getThis(), receiver + at(thisJoinPoint));
      // then we proceed with the method execution
      Object obj = proceed();
      // after the method executes, we discard the arguments
      targets = (HashMap)argStack.pop();
      return obj;
    }
  // END INSERT YOUR CODE
}


